# Wrdap.rb version 1.02 (coding: Windows-31J)  2014/09/29
  # an ruby library for Word OLE control
  # Copyright (C) T. Yoshiizumi, 2013-2014 All rights reserved.
require "win32ole"
require "nkf"
require "csv"
require "time"
unless defined?(PandocRuby)
  begin
    require "pandoc-ruby"
  rescue LoadError
  end
end

module WrdConstant
end

# ʂɗp郁\bh
module Wrd
  module_function()
  def fullpath(fname)
    fso = WIN32OLE.new('Scripting.FileSystemObject')
    return fso.GetAbsolutePathName(fname)
  end

  def filename2(fname)
    fname = fullpath(fname)
    dd = File.dirname(fname).gsub(/\//, "\\")
    unless dd =~ /\\$/
      dd = dd + "\\"
    end
    ff = File.basename(fname)
    return [dd, ff]
  end

  def filename3(fname)
    fname = fullpath(fname)
    dd = File.dirname(fname).gsub(/\//, "\\")
    unless dd =~ /\\$/
      dd = dd + "\\"
    end
    ff = File.basename(fname, ".*")
    ee = File.extname(fname)
    return [dd, ff, ee]
  end

      # [h֘A̒萔ǂݍ
  def wd_load()
    begin
      wrdw = WIN32OLE.new('Word.Application')
    rescue
      wrdw = nil
    end
    if wrdw
      wrdw.Visible = false
      unless defined?(WrdConstant::CONSTANTS)
        WIN32OLE.const_load(wrdw, WrdConstant)
      end
      wrdw.Quit
    end
  end

      # page_setup, paragraph_adjust𕪂
  def info_divide(info_str)
    adjust_types = %w(center left right justify distribute pagebreak)
    units = info_str.split(/\n\n/)
    psi_a = []  # page_setup_info
    pa_a = []  # paragraph_adjust
    units.each do |unit|
      lines = unit.split(/\n/)
      if adjust_types.include?(lines.last.downcase) or
          lines.last =~ /^pagebreak/i or lines.last =~ /^no/i
        pa_a << unit
      else
        psi_a << unit
      end
    end
    return [psi_a.join("\n\n") + "\n", pa_a.join("\n\n") + "\n"]
  end

  def time2str(x)
    if x.class == Time
      x = x.to_s.sub(/ +[\+\-]\d+$/, "")
      x = x.sub(/( +|\:)0+$/, "") while x =~ /( +|\:)0+$/
      x = x + ":00"  if x =~ / +\d+$/
    elsif x.class == Array
      for i in 0...x.size
        x[i] = time2str(x[i])
      end
    elsif x.class == Hash
      hs = {}
      x.each {|key, val|
        hs[time2str(key)] = time2str(val)
      }
      x.clear
      x = hs
    end
    return x
  end

  def to_num(x)
    if x.class == String
      if x =~ /^-?\d+$/
        x = x.to_i
      elsif x =~ /^(-?\d+)\.0+$/
        x = $1.to_i
      elsif x =~ /^-?\d+\.\d+$|^-?\d+\.\d+[Ee](-|\+)*\d+$/
        x = x.to_f
      elsif x =~ /^\d{4}[\/\-]\d\d?[\/\-]\d\d?( +\d\d?:\d\d?(:\d\d?)?)?$/ or
        x =~ /^\d{4}[\/\-]\d\d?[\/\-]\d\d? +\d\d?:\d\d?:\d\d?( +[\+\-]?\d+)?$/
        x = Time.parse(x)
      end
    elsif x.class == Array
      for i in 0...x.size
        x[i] = to_num(x[i])
      end
    elsif x.class == Hash
      hs = {}
      x.each {|key, val|
        hs[to_num(key)] = to_num(val)
      }
      x.clear
      x = hs
    end
    return x
  end

  def get_sep(str)  # ؂蕶̔
    cct = tct = 0
    if str.class == String
      str.gsub(/,/) {|ptn|
        cct += 1
        ptn = ''
      }
      str.gsub(/\t/) {|ptn|
        tct += 1
        ptn = ''
      }
    end
    return (tct > cct) ? "\t" : ","
  end

  def str2ary(str, sep=nil)  # zɕϊ
    sep = get_sep(str)  if sep == nil
    ary = (RUBY_VERSION < "1.9") ? CSV.parse(str, sep) :
        CSV.parse(str, {:col_sep=>sep})
    ary.map! {|row|
      row.map! {|x|
        x = x.to_s
        if x =~ /^\s*$/
          x = nil
        end
        x
      }
      row.pop  while row.size>0 and row.last==nil
      row
    }
    ary = to_num(ary)
    return ary
  end

  def ary2str(aa, sep=',')  # z𕶎ɕϊ
    aa = time2str(aa)
    if aa.class == Array and aa[0].class != Array
      aa = [aa]
    end
    aa.map! {|row|
      row.map! {|x|
        if x.to_s =~ /^\s*$/
          x = nil
        end
        x
      }
    }
    str = ''
    aa.each {|row|
      row = [row]  if row.class != Array
      line = (RUBY_VERSION < "1.9") ? CSV.generate_line(row, sep) :
          CSV.generate_line(row, {:col_sep=>sep})
      line.chomp!
      str += "#{line}\n"
    }
    return str
  end

  def ary2tbl(ary)
    if !(ary.class == Array and ary[0].class == Array and
         ary.size > 1)
      return nil
    end
    sep_flag = true
    ary[1].each do |x|
      sep_flag = false  unless x =~ /^[\-\:]+$/
    end
    unless sep_flag
      w1 = ary[1].dup
      w1.map! {|z|  z = '---'}
      w0 = ary.shift
      ary.unshift(w1)
      ary.unshift(w0)
    end
    str = ary2str(ary, "\032")
    str = str.gsub(/\|/, "\\|")
    str = str.gsub(/\032/, "|")
    lines = str.split(/\n/)
    for i in 0...lines.size
      lines[i] = "|" + lines[i]
    end
    str = lines.join("\n") + "\n"
    return str
  end

  def set_pandoc_path()
    unless defined?(PandocRuby)
      return
    end
    ww = ENV['HOMEDRIVE'] + ENV['HOMEPATH'] +
        "\\AppData\\Local\\pandoc"
    ww = ww.gsub(/\\/, "/")
    if test(?e, "#{ww}/pandoc.exe")
      PandocRuby.bin_path = ww
    end
  end

  def pandoc_convert(str, *opt_ary)
    unless defined?(PandocRuby)
      STDERR.puts "'pandoc-ruby' has not loaded."
      return nil
    end
    input_type = :markdown
    output_type = :html
    if str =~ /<html[^>]*>.+<\/html>/im
      input_type = :html
      str = str.sub(/<title[^>]*>.*?<\/title>/im, "<title></title>")
    end
    str = NKF.nkf("-m0xw", str)
    hs = {}
    ary = []
    opt_ary.each do |opt|
      next  unless opt
      if opt.class == Hash
        opt.each do |key, val|
          next  unless val
          if key.class != Symbol
            key = key.to_s.sub(/^\-+/, "").gsub(/\-/, "_").to_sym
          end
          if val.class != Symbol
            val = val.to_s.sub(/^\-+/, "").gsub(/\-/, "_").to_sym
          end
          hs[key] = val
        end
      else  # Hashł͂Ȃ
        opt = opt.to_s.sub(/^\-+/, "").gsub(/\-/, "_").to_sym
        ary << opt
      end
    end
    hs[:from] = input_type  unless hs[:from]
    hs[:to] = output_type  unless hs[:to]
    ary << hs
    output_str = PandocRuby.new(str, *ary).convert
    return output_str
  end

  def pandoc_opt(opt_ary)
    hs = {}
    var = []
    ary = []
    opt_ary.each do |opt|
      next  unless opt
      if opt.class == Hash
        opt.each do |key, val|
          next  unless val
          if key.class != Symbol
            key = key.to_s.sub(/^\-+/, "").gsub(/\-/, "_").to_sym
          end
          if key == :V or key == :variable
            var << val
            next
          end
          if val.class != Symbol
            val = val.to_s.sub(/^\-+/, "").gsub(/\-/, "_").to_sym
          end
          hs[key] = val
        end
      else  # Hashł͂Ȃ
        opt = opt.to_s.sub(/^\-+/, "").gsub(/\-/, "_").to_sym
        ary << opt
      end
    end
    return [hs, var, ary]
  end

  def pandoc_docx(str, *opt_ary)
    unless defined?(PandocRuby)
      STDERR.puts "'pandoc-ruby' has not loaded."
      return nil
    end
    hs, var, ary = pandoc_opt(opt_ary)
    hs[:to] = :docx
    ary << hs
    var.each {|x|  ary.push({:V=>x})}
    return pandoc_convert(str, *ary)
  end

  def pandoc_html(str, *opt_ary)
    unless defined?(PandocRuby)
      STDERR.puts "'pandoc-ruby' has not loaded."
      return nil
    end
    hs, var, ary = pandoc_opt(opt_ary)
    hs[:to] = :html
    ary << hs
    var.each {|x|  ary.push({:V=>x})}
    return pandoc_convert(str, *ary)
  end

  def pandoc_tex(str, *opt_ary)
    unless defined?(PandocRuby)
      STDERR.puts "'pandoc-ruby' has not loaded."
      return nil
    end
    hs, var, ary = pandoc_opt(opt_ary)
    hs[:to] = :latex
    ary << hs
    dclass = false
    var.each do |x|
      dclass = true  if x.to_s =~ /^documentclass/i
    end
    var << "documentclass:jarticle"  unless dclass
    var.each {|x|  ary.push({:V=>x})}
    tex_str = pandoc_convert(str, *ary)
    return tex_str
  end

  # xxx, yyy2, zzz_a, zzz["key"] Ȃǂ̂Rd˃p^[ERBpɕϊ
      # u<% cc %>v̕ɂ͕ϊȂ
  def erb_three(str)
    str = str.gsub(/\<\%/, "\x01\x7f")
    str = str.gsub(/\%\>/, "\x7f\x02")
    ary = []
    while str =~ /\x01\x7f([^\x7f]+)\x7f\x02/
      ptn = $1
      ary << ptn
      rstr = sprintf("\x19\x7f%d\x7f\x1a", ary.size-1)
      str = str.sub(/\x01\x7f[^\x7f]+\x7f\x02/, rstr)
    end
    reg = /([a-z])\1\1(\d+|_[A-Za-z0-9]+|\[.+?\])*/  # rrrȂǂ̌op^[
    str = str.gsub(reg) do |ptn|
      ptn_str = ptn.inspect
      ptn = "<%= (!defined?(#{ptn}) || #{ptn} == nil) ? #{ptn_str} : #{ptn} %>"
    end
    while str =~ /\x19\x7f(\d+)\x7f\x1a/
      n = $1.to_i
      ptn = ary[n]
      str = str.sub(/\x19\x7f\d+\x7f\x1a/, "<%#{ptn}%>")
    end
    str = str.gsub(/\x01\x7f/, "<%")
    str = str.gsub(/\x7f\x02/, "%>")
    return str
  end
end

# [h̃hLg߂̃NX
class Wrdoc
  include WrdConstant

    TypeExp = {1=>'Standard', 2=>'Class', 3=>'UserForm'}
    Fext = {1=>'.bas', 2=>'.cls', 3=>'.frm'}
    PageProps = {"p̉"=>"PageWidth", "p̏c̒"=>"PageHeight",
        "Ps̕"=>"CharsLine", "Py[W̍s"=>"LinesPage",
        "]"=>"TopMargin", "]"=>"BottomMargin",
        "]"=>"LeftMargin", "E]"=>"RightMargin",
        "wb_̍"=>"HeaderDistance",
        "tb^̍"=>"FooterDistance", "K^["=>"Gutter",
        "ig"=>"TextColumns.Count",
        "igE"=>"TextColumns.LineBetween"}
    MmProp = %w(TopMargin BottomMargin LeftMargin RightMargin) +
        %w(HeaderDistance FooterDistance Gutter PageWidth PageHeight)
    LastPageInfo = {"y[W"=>"WdActiveEndPageNumber",
        "ŏIy[Wԍ"=>"WdActiveEndAdjustedPageNumber",
        "ŏIy[W̍s"=>"WdFirstCharacterLineNumber"}

  def initialize(wrd)
    @app = wrd
    @obj = @open_type = @filename = nil
  end
  attr_accessor :app
  attr_accessor :obj
  attr_accessor :open_type
  attr_accessor :filename

  def close
    @app.doc_close(self)
  end

  # t@C̊gq .doc ȂǂɂȂ悤
  def filename_arrange(fname)
    w = fname.gsub(/\\/, "/")
    e = File.extname(w)
    d = File.dirname(w)
    f = File.basename(w, ".*")
    if d != ""
      d = d.sub(/\/$/, "")
      d = d.gsub(/\//, "\\") + "\\"
    end
    res = d + f
    if @app.ext_type[e.downcase] != nil
      res = res + e
    else
      res = res + ".doc"
    end
    return res
  end

  def save(save_name = nil)
    return  unless @obj
    ext_type = @app.ext_type
    da_v = @app.display_alert(false)
    error_msg = nil
    if save_name == nil
      if @open_type == 'OPEN'
        ffmt = ext_type[File.extname(@filename).downcase]
        if ffmt
          begin
            @obj.SaveAs({'FileName'=>@filename, 'FileFormat'=>ffmt})
          rescue
            error_msg = $!
          end
        else
          begin
            @obj.Save  # ㏑ۑ
          rescue
            error_msg = $!
          end
        end
      else
        outfile = filename_arrange(@filename)
        ffmt = ext_type[File.extname(outfile).downcase]
        begin
          @obj.SaveAs({'FileName'=>outfile, 'FileFormat'=>ffmt})
        rescue
          error_msg = $!
        end
      end
    else  # save_namew肳ꂽꍇ
      outfile = Wrd::fullpath(save_name)
      ffmt = ext_type[File.extname(outfile).downcase]
      unless ffmt
        outfile = filename_arrange(outfile)
        ffmt = ext_type[File.extname(outfile).downcase]
      end
      begin
        @obj.SaveAs({'FileName'=>outfile, 'FileFormat'=>ffmt})
      rescue
        error_msg = $!
      end
    end
    @app.display_alert(da_v)
    if error_msg
      svname = !save_name ? self.name : save_name
      STDERR.printf("Wrdoc.save: can't save '%s'\n%s\n\n", svname, error_msg)
    end
  end

  def name  # hLg̖O(tpXłȂEgq܂)Ԃ
    return  File.basename(@filename)
  end

  def page_setup(page_info = nil, *sect_ary)
    res = []
    return res  unless @obj
    if page_info.class == Hash
      page_val = page_info
    elsif page_info.class == String
      page_val = {}
      if !page_info.index("\n") and test(?f, page_info)
        page_info = File.read(page_info)
      end
      page_info.split(/\n/).each do |line|
        line = line.sub(/^\s+/, "")
        a = (line =~ /^\s*([^\s]+)\s+([^\s].+[^\s])\s*$/) ? [$1, $2] : [line]
        a[1] = (a[1].to_s =~ /^\s*$/) ?  nil : a[1]
        page_val[a[0]] = a[1]
      end
    else
      return res
    end
    if sect_ary.size == 0
      sects = @obj.Sections
    else
      sects = []
      sect_ary.each do |arg|
        flag = [Fixnum,Bignum].include?(arg.class)
        if flag and arg <= @obj.Sections.Count
          sects << @obj.Sections(arg)
        elsif !flag
          sects << arg
        end
      end
    end
    sects.each do |sect|
      PageProps.each do |key, prop_name|
        next  unless page_val[key]
        if MmProp.include?(prop_name)  # ~Pʂ̂
          str = "sect.PageSetup.#{prop_name} = " +
              "@app.MillimetersToPoints(#{page_val[key]})"
        elsif prop_name == "TextColumns.Count"
          pname = "TextColumns.SetCount(#{page_val[key]})"
          str = "sect.PageSetup.#{pname}"
        else
          str = "sect.PageSetup.#{prop_name} = " +
              "#{page_val[key]}"
        end
        eval(str)
        res << key
      end
    end
    return res
  end
  alias :ps :page_setup

  def page_setup_info(*sect_ary)
    res = []
    if sect_ary.size == 0
      sects = @obj.Sections
    else
      sects = []
      sect_ary.each do |arg|
        flag = [Fixnum,Bignum].include?(arg.class)
        if flag and arg <= @obj.Sections.Count
          sects << @obj.Sections(arg)
        elsif !flag
          sects << arg
        end
      end
    end
    sects.each do |sect|
      hs = {}
      PageProps.each do |key, prop_name|
        if MmProp.include?(prop_name)  # ~Pʂ̂
          str = "@app.PointsToMillimeters(sect.PageSetup.#{prop_name})"
        else
          str = "sect.PageSetup.#{prop_name}"
        end
        v = eval(str)
        if MmProp.include?(prop_name)
          v = sprintf("%.1f", v).to_f
        elsif prop_name == "TextColumns.LineBetween"
          if v == 0
            v = false
          elsif v == -1 or v == 1
            v = true
          end
        end
        hs[key] = v
      end
      res << hs
    end
    return res
  end
  alias :psi :page_setup_info

  def page_props()
    return PageProps.dup
  end

  def last_page_info()  # y[WԂ
    res = {}
    if @obj
      lpos = @obj.Range.End - 1
      lchr = @obj.Range(lpos, lpos)
      LastPageInfo.each do |key, val|
        res[key] = eval("lchr.Information(#{val})")
      end
    end
    return res
  end
  alias :lpi :last_page_info

      # [h̒iɂĒ񂹂Ȃǂ̔zuƉy[W}̏
  def paragraph_adjust(adjust_str)
    if !adjust_str.index("\n") and test(?f, adjust_str)
      adjust_str = File.read(adjust_str)
    end
    ary = []
    adjust_str.split(/\n\n/).each do |unit|
      unit = unit.gsub(/  +\n/, "\v")
      w = unit.split(/\n/)
      if w[0] =~ /^\/.+\/[!-~]*$/
        w[0] = eval(w[0])
      end
      ary << w
    end
    info_msg = ''
    cnt = @obj.Paragraphs.Count
    for i in 1..cnt
      rng = @obj.Paragraphs(i).Range
      str = rng.Text
      str = str.sub(/[\x01-\x1f]+$/, "")
      str = str.gsub(/[\r\n]+/, "\v")
      for j in 0...ary.size
        info = ary[j].dup
        if info.class != Array or
            !((info[0].class == String and info[0] == str) or
            (info[0].class == Regexp and info[0] =~ str))
          next
        end
        info.shift
        while winfo = info.shift
          case winfo.downcase
          when "center"
            rng.ParagraphFormat.Alignment = WdAlignParagraphCenter
            info_msg += "*(#{i}i): #{str}\n"
            ary[j] = nil
          when "left"
            rng.ParagraphFormat.Alignment = WdAlignParagraphLeft
            info_msg += "*(#{i}i): #{str}\n"
            ary[j] = nil
          when "right"
            rng.ParagraphFormat.Alignment = WdAlignParagraphRight
            info_msg += "*E(#{i}i): #{str}\n"
            ary[j] = nil
          when "justify"
            rng.ParagraphFormat.Alignment = WdAlignParagraphJustify
            info_msg += "*[(#{i}i): #{str}\n"
            ary[j] = nil
          when "distribute"
            rng.ParagraphFormat.Alignment = WdAlignParagraphDistribute
            info_msg += "*ϓt(#{i}i): #{str}\n"
            ary[j] = nil
          else
            if winfo =~ /^pagebreak/i
              break_flag = true
              cmp_str = winfo.sub(/^pagebreak\s*/i, "")
              if cmp_str =~ /^[!<=>]+ *\d+$/
                sn = rng.Information(WdActiveEndSectionNumber)
                lp = @obj.Sections(sn).PageSetup.LinesPage
                ln = rng.Information(WdFirstCharacterLineNumber)
                fml = "(lp-ln+1)#{cmp_str}"
                break_flag = false  unless eval(fml)
              end
              if break_flag
                rng.Collapse('Direction'=>WdCollapseStart)
                rng.InsertBreak('Type'=>WdPageBreak)
                info_msg += "*y[W(#{i}i): " +
                    "#{str}(i̒Oŉy[W)\n"
              else
                info_msg += "*y[WȂ(#{i}i): " +
                    "#{str}(cs߉y[WȂ)\n"
              end
              ary[j] = nil
            elsif winfo =~ /^no/i
              info_msg += "*Ȃ(#{i}i): #{str}\n"
              ary[j] = nil
            end
          end
        end
        if ary[j] == nil
          break
        end
      end
      ary.delete(nil)
    end
    return info_msg
  end
  alias :pa :paragraph_adjust

  def table_border(style = nil, # \̌r𒲐
      outside_style = nil, outside_width = nil, *tbl_nums)
    return  unless @obj
    style = WdLineStyleSingle  unless style
    outside_style = WdLineStyleSingle  unless outside_style
    outside_width = WdLineWidth075pt  unless outside_width
    bd4 = [WdBorderTop, WdBorderLeft, WdBorderBottom, WdBorderRight]
    tbl_count = 0
    res_count = 0
    @obj.Content.Tables.each do |tbl|  # \PÂmF
      tbl_count += 1
      next  if tbl_nums.size > 0 and !tbl_nums.include?(tbl_count)
      res_count += 1
          # SrύX
      tbl.Rows.each do |row|
        row.Cells.each {|cell|
          bd4.each {|bn|
            bdr = cell.Range.Borders(bn)
            begin
              bdr.LineStyle = style
              # bdr.LineWidth = WdLineWidth050pt
            rescue
              dummy = 0;
            end
          }
        }
      end
          # ľrύX
      tbl.Rows(1).Cells.each {|cell|
        bdr = cell.Range.Borders(WdBorderTop)
        begin
          bdr.LineStyle = outside_style
          bdr.LineWidth = outside_width
        rescue
          dummy = 0;
        end
      }
      rcount = tbl.Rows.Count
      tbl.Rows(rcount).Cells.each {|cell|
        bdr = cell.Range.Borders(WdBorderBottom)
        begin
          bdr.LineStyle = outside_style
          bdr.LineWidth = outside_width
        rescue
          dummy = 0;
        end
      }
      tbl.Columns(1).Cells.each {|cell|
        bdr = cell.Range.Borders(WdBorderLeft)
        begin
          bdr.LineStyle = outside_style
          bdr.LineWidth = outside_width
        rescue
          dummy = 0;
        end
      }
      ccount = tbl.Columns.Count
      tbl.Columns(ccount).Cells.each {|cell|
        bdr = cell.Range.Borders(WdBorderRight)
        begin
          bdr.LineStyle = outside_style
          bdr.LineWidth = outside_width
        rescue
          dummy = 0;
        end
      }
    end
    return res_count
  end
  alias :tb :table_border

  def table_row(align_str, *tbl_nums)
    res = []
    tbl_ct = 0
    @obj.Content.Tables.each do |tbl|  # \PÂmF
      tbl_ct += 1
      next  if tbl_nums.size > 0 and !tbl_nums.include?(tbl_ct)
      ary = []
      tbl.Rows(1).Cells.each do |cell|
        w = cell.Range.Text.to_s.sub(/[\x01-\x1f]+\Z/, "")
        w = nil  if w == ''
        ary << w
      end
      i = -1
      tbl.Rows(1).Cells.each do |cell|
        next  unless ary[(i+=1)]
        rng = cell.Range
        case align_str.downcase
        when "center"
          rng.ParagraphFormat.Alignment = WdAlignParagraphCenter
        when "left"
          rng.ParagraphFormat.Alignment = WdAlignParagraphLeft
        when "right"
          rng.ParagraphFormat.Alignment = WdAlignParagraphRight
        when "justify"
          rng.ParagraphFormat.Alignment = WdAlignParagraphJustify
        when "distribute"
          rng.ParagraphFormat.Alignment = WdAlignParagraphDistribute
        end
      end
      res << ary
    end
    return res
  end

  def table_col(align_str, *tbl_nums)
    res = []
    tbl_ct = 0
    @obj.Content.Tables.each do |tbl|  # \PÂmF
      next  if tbl_nums.size > 0 and !tbl_nums.include?(tbl_ct)
      ary = []
      tbl.Columns(1).Cells.each do |cell|
        w = cell.Range.Text.to_s.sub(/[\x01-\x1f]+\Z/, "")
        w = nil  if w == ''
        ary << w
      end
      i = -1
      tbl.Columns(1).Cells.each do |cell|
        next  unless ary[(i+=1)]
        rng = cell.Range
        case align_str.downcase
        when "center"
          rng.ParagraphFormat.Alignment = WdAlignParagraphCenter
        when "left"
          rng.ParagraphFormat.Alignment = WdAlignParagraphLeft
        when "right"
          rng.ParagraphFormat.Alignment = WdAlignParagraphRight
        when "justify"
          rng.ParagraphFormat.Alignment = WdAlignParagraphJustify
        when "distribute"
          rng.ParagraphFormat.Alignment = WdAlignParagraphDistribute
        end
      end
      res << ary
    end
    return res
  end

  def check_page_number(*sect_ary)  # y[WԍbȂmF
    res = []
    return res  unless @obj
    if sect_ary.size == 0
      sects = @obj.Sections
    else
      sects = []
      sect_ary.each do |arg|
        flag = [Fixnum,Bignum].include?(arg.class)
        if flag and arg <= @obj.Sections.Count
          sects << @obj.Sections(arg)
        elsif !flag
          sects << arg
        end
      end
      if sects.size == 0
        return res
      end
    end
    sects.each do |sect|
      w = {'header'=>false, 'footer'=>false}
      hdft = sect.Headers(WdHeaderFooterPrimary)
      w['header'] = true  if hdft.PageNumbers.Count > 0
      hdft = sect.Footers(WdHeaderFooterPrimary)
      w['footer'] = true  if hdft.PageNumbers.Count > 0
      res << w
    end
    return res
  end
  alias :cpn :check_page_number

  def del_page_number(*sect_ary)
    aa = check_page_number(*sect_ary)
    for i in 1..aa.size
      sect = @obj.Sections(i)
      hs = aa[i-1]
      if hs['header']
        hdft = sect.Headers(WdHeaderFooterPrimary)
        hdft.Range.Text = "\r"
      end
      if hs['footer']
        hdft = sect.Footers(WdHeaderFooterPrimary)
        hdft.Range.Text = "\r"
      end
    end
    return check_page_number(*sect_ary)
  end
  alias :dpn :del_page_number

  def add_page_number(*sect_ary)  # tb^[Ƀy[Wԍt()
    res = false
    return res  unless @obj
    dres = del_page_number(*sect_ary)
    count = 0
    dres.each do |hs|
      count += 1  if hs['header'] or hs['footer']
    end
    if count > 0  # y[Wԍ폜łȂ
      return res
    end
    if sect_ary.size == 0
      sects = @obj.Sections
    else
      sects = []
      sect_ary.each do |arg|
        flag = [Fixnum,Bignum].include?(arg.class)
        if flag and arg <= @obj.Sections.Count
          sects << @obj.Sections(arg)
        elsif !flag
          sects << arg
        end
      end
      if sects.size == 0
        return res
      end
    end
    sects.each do |sect|
      hdft = sect.Footers(WdHeaderFooterPrimary)
      hdft.PageNumbers.Add(
          'PageNumberAlignment'=>WdAlignPageNumberCenter,
          'FirstPage'=>true)
      res = true  if hdft.PageNumbers.Count > 0
    end
    return res
  end
  alias :apn :add_page_number

  def std_font(jfont=nil, afont=nil, size=nil)
    fnt = @obj.Styles(WdStyleNormal).Font
    fnt.NameFarEast = jfont  if jfont.class == String
    fnt.NameAscii = afont  if afont.class == String
    fnt.Size = size  if [Float,Fixnum].include?(size.class)
    return [fnt.NameFarEast, fnt.NameAscii, fnt.Size]
  end
  alias :sf :std_font

  def get_info(sect_num = nil)
    hs = {}
    if !sect_num
      sect_num = 1
    elsif ![Fixnum,Bignum].include?(sect_num.class)
      num = 0
      @obj.Sections.each do |sect|
        num += 1
        if sect == sect_num
          sect_num = num
          break
        end
      end
      if ![Fixnum,Bignum].include?(sect_num.class)
        return ''
      end
    end
    ary = page_setup_info(sect_num)
    if ary.size > 0
      hs.update(ary[0])
    end
    page_msg = "Ȃ"
    pres = check_page_number(sect_num)
    if pres.size > 0
      w = pres[sect_num-1]
      if w['header'] and w['footer']
        page_msg = "wb_[ƃtb^[ɂ"
      elsif w['header']
        page_msg = "wb_[ɂ"
      elsif w['footer']
        page_msg = "tb^[ɂ"
      end
    end
    hs["y[Wԍ"] = page_msg
    ary = std_font()
    hs["W{tHg"] = ary[0]
    hs["WtHg"] = ary[1]
    hs["WtHgTCY"] = ary[2]
    hs.update(last_page_info())
    str = ''
    hs.each do |key, val|
      str += sprintf("%s\t%s\n", key, val)
    end
    return str
  end

  def set_info(arg, sect_num = nil)
    sect_num = 1  unless sect_num
    hs = {}
    ps_str = pa_str = nil
    adjust_msg = nil
    get_msg = nil
    if arg.class == Hash
      hs = arg
    elsif arg.class == String
      if !arg.index("\n") and test(?f, arg)
        arg = File.read(arg)
      end
      ps_str, pa_str = Wrd::info_divide(arg)
      ps_str.split(/\n/).each do |line|
        line = line.sub(/^\s+/, "")
        a = (line =~ /^\s*([^\s]+)\s+([^\s].+[^\s])\s*$/) ? [$1, $2] : [line]
        a[1] = (a[1].to_s =~ /^\s*$/) ?  nil : a[1]
        hs[a[0]] = a[1]
      end
    else
      return [nil, nil, get_info()]
    end
    if pa_str.class == String
      adjust_msg = paragraph_adjust(pa_str)
    end
    if hs.size == 0
      return [nil, adjust_msg, get_info()]
    end
    keys = []
    ary = self.page_setup(hs, sect_num)
    if ary.size > 0
      keys = keys + ary
    end
    if %w( tb^[ɂ t t ).include?(hs["y[Wԍ"])
      if self.add_page_number(sect_num)
        keys << "y[Wԍ"
      end
    end
    font_keys = %w(W{tHg WtHg WtHgTCY)
    ary = []
    font_keys.each do |key|
      ary << hs[key]
      keys << key  if hs[key]
    end
    if ary != [nil, nil, nil]
      ary[2] = Wrd::to_num(ary[2])
      self.std_font(*ary)
    end
    get_msg = get_info()
    lines = get_msg.split(/\n/)
    str = ''
    lines.each do |line|
      key, val = (line =~ /^\s*([^\s]+)\s+([^\s].+[^\s])\s*$/) ? 
          [$1, $2] : [line]
      if keys.include?(key)
        str += sprintf("%s\t%s\n", key, val)
      end
    end
    return [str, adjust_msg, get_msg]
  end

  def method_missing(sym, *arg)
    name = sym.to_s
    if name =~ /^[A-Z_]/
      return @obj.send(sym, *arg)
    else
      STDERR.puts "undefined method `#{name}' for Wrdoc (NameError)"
    end
  end
end

# Word Application߂̃NX
class Wrdap
  include WrdConstant

  def init_set()
    @obj = @word_version = @ext_type = nil
    @order = @last = nil
    @auto_quit = false
    @auto_close = false
    @docs = []
    begin
      @obj = WIN32OLE.new('Word.Application')
    rescue
      @obj = nil
    end
    if @obj
      @obj.Visible = true
      unless defined?(WrdConstant::CONSTANTS)
        wv = $VERBOSE
        $VERBOSE = nil
        WIN32OLE.const_load(@obj, WrdConstant)
        $VERBOSE = wv
      end
      @word_version = @obj.Version.to_f
      if @word_version >= 12.0
        @ext_type = {".doc"=>WdFormatDocument, ".rtf"=>WdFormatRTF,
            ".htm"=>WdFormatHTML, ".html"=>WdFormatHTML, ".txt"=>WdFormatText,
            ".docx"=>WdFormatXMLDocument,
            ".docm"=>WdFormatXMLDocumentMacroEnabled,
            ".odt"=>WdFormatOpenDocumentText,
            ".xml"=>WdFormatXML}
      else
        @ext_type = {".doc"=>WdFormatDocument, ".rtf"=>WdFormatRTF,
            ".htm"=>WdFormatHTML, ".html"=>WdFormatHTML, ".txt"=>WdFormatText}
        if defined?(WdFormatXML)
          @ext_type[".xml"] = WdFormatXML
        end
      end
    end
  end
  private :init_set
  attr_reader :obj
  attr_reader :word_version
  attr_reader :ext_type
  attr_reader :order
  attr_reader :last
  attr_accessor :auto_quit
  attr_accessor :auto_close

  def Wrdap.callback
    proc { $WrdapObject.quit()  if $WrdapObject != nil }
  end

  def initialize(*fname, &block)
    ObjectSpace.define_finalizer(self, Wrdap.callback)
    init_set()
    $WrdapObject = self  if @obj
    if @obj and fname.size > 0
      @last = fname.size
      for n in 0...@last
        @order = n + 1
        doc = doc_open(fname[n])
        if block
          block.call(doc)
          doc_close(doc)  if @auto_close
        end
      end
      @order = @last = nil
      self.quit  if block
    end
  end

  def quit()
    if @obj
      display_alert(false)
      if @obj.Documents.Count > 0
        @obj.Documents.Close({'SaveChanges' => WdDoNotSaveChanges})
      end
      @obj.Quit
      @docs = []
      @obj = @word_version = @ext_type = nil
      @order = @last = nil
      $WrdapObject = nil
    end
  end

  def opens(*fname, &block)
    res = []
    if @obj and fname.size > 0
      @last = fname.size
      for n in 0...@last
        @order = n + 1
        doc = doc_open(fname[n])
        if block
          block.call(doc)
          doc_close(doc)  if @auto_close
        else
          res << doc
        end
      end
      @order = @last = nil
      self.quit  if block and @auto_quit
    end
    if res.size < 1
      res = nil
    end
    return res
  end

  def opens_once(*fname, &block)
    unless block
      return
    end
    res = []
    if @obj and fname.size > 0
      for n in 0...fname.size
        doc = doc_open(fname[n])
        res << doc
      end
    end
    if res.size > 0
      block.call(*res)
      if @auto_close
        res.each {|doc|
          doc_close(doc)
        }
      end
      self.quit  if @auto_quit
    end
  end

  def doc_open(param)
    doc = nil
    fname = nil
    if param
      if param.class == String
        fname = param.dup
        param = Hash.new
      elsif param.class == Hash
        fname = param['Filename']
      else
        param = nil
      end
    end
    if @obj and param and fname
      fname = Wrd::fullpath(fname)
      param['Filename'] = fname
      doc = select_doc(fname)
      unless doc  # ܂JĂȂhLgł
        doc = Wrdoc.new(self)
        if test(?e, fname)  # ̃t@CI[v
          display_alert(false) do
            doc.obj = @obj.Documents.Open(param)
            doc.open_type = 'OPEN'
          end
        else  # ݂Ȃt@CȂVK쐬
          doc.obj = @obj.Documents.Add()
          doc.open_type = 'ADD'
        end
        doc.filename = fname
      end
      if doc
        @docs << doc
      end
    end
    return doc
  end

  def doc_close(doc)
    if doc
      if doc.obj
        da_v = self.display_alert(false)
        doc.obj.Close({'SaveChanges' => WdDoNotSaveChanges})
        self.display_alert(da_v)
      end
      doc.app = doc.obj = doc.open_type = doc.filename = nil
      @docs.delete(doc)
    end
  end

  def select_doc(target)
    doc = nil
    if target.class == String
      @docs.each {|d|
        if d.name.casecmp(target) == 0
          doc = d
          break
        end
      }
    elsif [Fixnum,Bignum].include?(target.class)
      count = 0
      @docs.each {|d|
        count += 1
        if count == target
          doc = d
          break
        end
      }
    end
    return doc
  end
  private :select_doc

  def doc_names
    res = []
    @docs.each {|b|
      res << b.name
    }
    return res
  end

  def display_alert(val, &block)
    before_val = @obj.DisplayAlerts
    @obj.DisplayAlerts = val
    if block
      block.call()
      @obj.DisplayAlerts = before_val
      return
    end
    return before_val
  end

  def each(&block)
    return  unless block
    @last = @docs.size
    @order = 0
    @docs.each {|doc|
      @order += 1
      block.call(doc)
    }
    @order = @last = nil
  end

  def version  # Wrdap̃o[W
    return 1.02
  end

  def addin_list(regex = nil)
    ary = []
    @obj.AddIns.each do |target|
      if regex.class != Regexp or regex =~ target.Name
        ary << [target.Name, target.FullName]
      end
    end
    return ary
  end

  def method_missing(sym, *arg)
    name = sym.to_s
    if name =~ /^[A-Z_]/
      return @obj.send(sym, *arg)
    else
      STDERR.puts "undefined method `#{name}' for Wrdoc (NameError)"
    end
  end
end

Wrd::set_pandoc_path()
include WrdConstant
